Compare commits

..
Author SHA1 Message Date
Serge Schneider 68cdf34cb4 Add xz-utils dependency
Closes #90
2017-07-28 13:22:03 +01:00
TJ Rana 3441133d1c Corrected various typos (#91)
* Rename License.md to LICENSE

* Correct typos

* Clean up code layout

Organize layout with extra lines
2017-07-27 12:11:07 +02:00
Claus Strasburger fe45b73987 Added docker-compose.yml for easy apt-cacher-ng startup 2017-07-17 12:21:37 +02:00
Claus Strasburger bab0fe3b0d Docker build: move to debian stretch 2017-07-17 12:21:28 +02:00
Russ Kubes 4d65b2b357 Export-image: Only disable metadata_csum feature if it's possibly enabled. 2017-07-17 11:36:43 +02:00
Serge Schneider 137efd2379 Update release notes 2017-07-10 14:29:11 +01:00
Serge Schneider dd7de2554c Update release notes 2017-07-05 11:23:54 +01:00
Serge Schneider 234c4b7937 Export-image: disable metadata_csum for compatibility with older SD card copiers 2017-07-03 16:40:23 +01:00
Serge Schneider be2018ee5f README: Add stage 5 description 2017-06-27 13:16:41 +01:00
Andrew Smith cdf1cf2aba Also use -v in error message 2017-06-27 13:10:09 +01:00
Andrew Smith 22c4105b57 Tell docker to delete the volume as well
Addresses #62

Because of the use of volumes the .img files (and everything else) will stay around on disk even when you do `docker rm pigen_work`. Passing `-v` deletes the volume as well and frees up disk space.
2017-06-27 13:10:09 +01:00
Jacob Siverskog d2f88a6e4f Update stage specification example
The previous example failed for me due to a missing SKIP in
stage5. While at it, complete the example with all steps needed to get
an image generated.
2017-06-27 13:09:40 +01:00
Thomas Phillips c92638438a Fixed running docker script from within pwd containing spaces 2017-06-27 13:08:08 +01:00
Thomas Phillips 50e5c01f57 Image build date now honours timezone 2017-06-27 13:06:50 +01:00
22 changed files with 68 additions and 24 deletions
+1
View File
@@ -5,3 +5,4 @@ postrun.sh
SKIP SKIP
.pc .pc
*-pc *-pc
apt-cacher-ng/
+2 -2
View File
@@ -1,10 +1,10 @@
FROM debian:jessie FROM debian:stretch
RUN apt-get -y update && \ RUN apt-get -y update && \
apt-get -y install \ apt-get -y install \
git vim parted \ git vim parted \
quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \ quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \
bsdtar libcap2-bin rsync grep \ bsdtar libcap2-bin rsync grep udev xz-utils \
&& rm -rf /var/lib/apt/lists/* && rm -rf /var/lib/apt/lists/*
COPY . /pi-gen/ COPY . /pi-gen/
View File
+20 -10
View File
@@ -13,7 +13,7 @@ On Debian-based systems:
```bash ```bash
apt-get install quilt parted realpath qemu-user-static debootstrap zerofree pxz zip \ apt-get install quilt parted realpath qemu-user-static debootstrap zerofree pxz zip \
dosfstools bsdtar libcap2-bin grep rsync dosfstools bsdtar libcap2-bin grep rsync xz-utils
``` ```
The file `depends` contains a list of tools needed. The format of this The file `depends` contains a list of tools needed. The format of this
@@ -41,6 +41,12 @@ The following environment variables are supported:
will not be included in the image, making it safe to use an `apt-cacher` or will not be included in the image, making it safe to use an `apt-cacher` or
similar package for development. similar package for development.
If you have Docker installed, you can set up a local apt caching proxy to
like speed up subsequent builds like this:
docker-compose up -d
echo 'APT_PROXY=http://172.17.0.1:3142' >> config
* `BASE_DIR` (Default: location of `build.sh`) * `BASE_DIR` (Default: location of `build.sh`)
**CAUTION**: Currently, changing this value will probably break build.sh **CAUTION**: Currently, changing this value will probably break build.sh
@@ -76,7 +82,7 @@ vi config # Edit your config file. See above.
``` ```
If everything goes well, your finished image will be in the `deploy/` folder. If everything goes well, your finished image will be in the `deploy/` folder.
You can then remove the build container with `docker rm pigen_work` You can then remove the build container with `docker rm -v pigen_work`
If something breaks along the line, you can edit the corresponding scripts, and If something breaks along the line, you can edit the corresponding scripts, and
continue: continue:
@@ -126,11 +132,11 @@ maintenance and allows for more easy customization.
standard console hardware permission groups. standard console hardware permission groups.
There are a few tools that may not make a whole lot of sense here for There are a few tools that may not make a whole lot of sense here for
development purposes on a minimal system such as basic python and lua development purposes on a minimal system such as basic Python and Lua
packages as well as the `build-essential` package. They are lumped right packages as well as the `build-essential` package. They are lumped right
in with more essential packages presently, though they need not be with in with more essential packages presently, though they need not be with
pi-gen. These are understandable for Raspbian's target audience, but if pi-gen. These are understandable for Raspbian's target audience, but if
you were looking for something between truly minimal and Raspbian-lite, you were looking for something between truly minimal and Raspbian-Lite,
here's where you start trimming. here's where you start trimming.
- **Stage 3** - desktop system. Here's where you get the full desktop system - **Stage 3** - desktop system. Here's where you get the full desktop system
@@ -138,12 +144,14 @@ maintenance and allows for more easy customization.
enhancements, etc. This is a base desktop system, with some development enhancements, etc. This is a base desktop system, with some development
tools installed. tools installed.
- **Stage 4** - complete Raspbian system. More development tools, an email - **Stage 4** - Raspbian system meant to fit on a 4GB card. More development
client, learning tools like Scratch, specialized packages like sonic-pi and tools, an email client, learning tools like Scratch, specialized packages
wolfram-engine, system documentation, office productivity, etc. This is like sonic-pi, system documentation, office productivity, etc. This is the
the stage that installs all of the things that make Raspbian friendly to stage that installs all of the things that make Raspbian friendly to new
new users. users.
- **Stage 5** - The official Raspbian Desktop image. Right now only adds
Mathematica.
### Stage specification ### Stage specification
@@ -156,8 +164,10 @@ from `./stage2` (if building a minimal system).
```bash ```bash
# Example for building a lite system # Example for building a lite system
touch ./stage3/SKIP ./stage4/SKIP echo "IMG_NAME='Raspbian'" > config
touch ./stage3/SKIP ./stage4/SKIP ./stage5/SKIP
rm stage4/EXPORT* rm stage4/EXPORT*
sudo ./build.sh # or ./build-docker.sh
``` ```
If you wish to build further configurations upon (for example) the lite If you wish to build further configurations upon (for example) the lite
+9 -5
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
DOCKER="docker" DOCKER="docker"
set +e set +e
$DOCKER ps >/dev/null 2>&1 $DOCKER ps >/dev/null 2>&1
@@ -12,9 +13,10 @@ if ! $DOCKER ps >/dev/null; then
fi fi
set -e set -e
config_mount=
config_mount=()
if [ -f config ]; then if [ -f config ]; then
config_mount="-v $(pwd)/config:/pi-gen/config:ro" config_mount=("-v" "$(pwd)/config:/pi-gen/config:ro")
source config source config
fi fi
@@ -45,7 +47,7 @@ fi
if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then
echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting." echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting."
echo "You can delete the existing container like this:" echo "You can delete the existing container like this:"
echo " docker rm $CONTAINER_NAME" echo " docker rm -v $CONTAINER_NAME"
exit 1 exit 1
fi fi
@@ -54,6 +56,7 @@ if [ "$CONTAINER_EXISTS" != "" ]; then
trap "echo 'got CTRL+C... please wait 5s';docker stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s';docker stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM
time $DOCKER run --rm --privileged \ time $DOCKER run --rm --privileged \
--volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \ --volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \
-e IMG_NAME=${IMG_NAME}\
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh; cd /pi-gen; ./build.sh;
@@ -62,8 +65,9 @@ if [ "$CONTAINER_EXISTS" != "" ]; then
else else
trap "echo 'got CTRL+C... please wait 5s'; docker stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s'; docker stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM
$DOCKER run --name "${CONTAINER_NAME}" --privileged \ $DOCKER run --name "${CONTAINER_NAME}" --privileged \
-v $(pwd)/deploy:/pi-gen/deploy \ -e IMG_NAME=${IMG_NAME}\
${config_mount} \ -v "$(pwd)/deploy:/pi-gen/deploy" \
"${config_mount[@]}" \
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh && cd /pi-gen; ./build.sh &&
+1 -1
View File
@@ -128,7 +128,7 @@ if [ -z "${IMG_NAME}" ]; then
exit 1 exit 1
fi fi
export IMG_DATE=${IMG_DATE:-"$(date -u +%Y-%m-%d)"} export IMG_DATE=${IMG_DATE:-"$(date +%Y-%m-%d)"}
export BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)" export BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
export SCRIPT_DIR="${BASE_DIR}/scripts" export SCRIPT_DIR="${BASE_DIR}/scripts"
+2 -1
View File
@@ -9,4 +9,5 @@ mkdosfs:dosfstools
capsh:libcap2-bin capsh:libcap2-bin
bsdtar bsdtar
grep grep
rsync rsync
xz:xz-utils
+10
View File
@@ -0,0 +1,10 @@
version: '2'
services:
apt-cacher-ng:
restart: unless-stopped
image: sameersbn/apt-cacher-ng:latest
ports:
- "3142:3142"
volumes:
- ./apt-cacher-ng:/var/cache/apt-cacher-ng
@@ -1,2 +1,3 @@
#!/bin/sh #!/bin/sh
exit 101 exit 101
+1 -1
View File
@@ -1,3 +1,3 @@
#/bin/bash -e #!/bin/bash -e
install -m 644 files/resolv.conf ${ROOTFS_DIR}/etc/ install -m 644 files/resolv.conf ${ROOTFS_DIR}/etc/
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
IMGID="$(fdisk -l ${IMG_FILE} | sed -n 's/Disk identifier: 0x\([^ ]*\)/\1/p')" IMGID="$(fdisk -l ${IMG_FILE} | sed -n 's/Disk identifier: 0x\([^ ]*\)/\1/p')"
+6 -1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
unmount_image ${IMG_FILE} unmount_image ${IMG_FILE}
@@ -50,8 +51,12 @@ ROOT_DEV=$(losetup --show -f -o ${ROOT_OFFSET} --sizelimit ${ROOT_LENGTH} ${IMG_
echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH" echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH"
echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH" echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH"
ROOT_FEATURES="^huge_file"
if grep -q "metadata_csum" /etc/mke2fs.conf; then
ROOT_FEATURES="^metadata_csum,$ROOT_FEATURES"
fi
mkdosfs -n boot -F 32 -v $BOOT_DEV > /dev/null mkdosfs -n boot -F 32 -v $BOOT_DEV > /dev/null
mkfs.ext4 -O ^huge_file $ROOT_DEV > /dev/null mkfs.ext4 -O $ROOT_FEATURES $ROOT_DEV > /dev/null
mount -v $ROOT_DEV ${ROOTFS_DIR} -t ext4 mount -v $ROOT_DEV ${ROOTFS_DIR} -t ext4
mkdir -p ${ROOTFS_DIR}/boot mkdir -p ${ROOTFS_DIR}/boot
@@ -1,4 +1,9 @@
UNRELEASED: UNRELEASED:
*
2017-07-05:
* New kernel and firmware
* Filesystem created without the metadata_csum feature
2017-06-21:
* Scratch 2 application included * Scratch 2 application included
* Thonny Python IDE included * Thonny Python IDE included
* New icons with thinner outlines * New icons with thinner outlines
+2 -2
View File
@@ -1,5 +1,5 @@
# dependencies_check # dependencies_check
# $@ Dependnecy files to check # $@ Dependency files to check
# #
# Each dependency is in the form of a tool to test for, optionally followed by # Each dependency is in the form of a tool to test for, optionally followed by
# a : and the name of a package if the package on a Debian-ish system is not # a : and the name of a package if the package on a Debian-ish system is not
@@ -21,7 +21,7 @@ dependencies_check()
done done
if [[ "$missing" ]]; then if [[ "$missing" ]]; then
echo "Reqired dependencies not installed" echo "Required dependencies not installed"
echo echo
echo "This can be resolved on Debian/Raspbian systems by installing:" echo "This can be resolved on Debian/Raspbian systems by installing:"
echo "$missing" echo "$missing"
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
bootstrap jessie ${ROOTFS_DIR} http://mirrordirector.raspbian.org/raspbian/ bootstrap jessie ${ROOTFS_DIR} http://mirrordirector.raspbian.org/raspbian/
fi fi
+1
View File
@@ -1,2 +1,3 @@
#!/bin/sh #!/bin/sh
exit 101 exit 101
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
-1
View File
@@ -6,4 +6,3 @@ update-alternatives --install /usr/bin/x-www-browser \
update-alternatives --install /usr/bin/gnome-www-browser \ update-alternatives --install /usr/bin/gnome-www-browser \
gnome-www-browser /usr/bin/chromium-browser 86 gnome-www-browser /usr/bin/chromium-browser 86
EOF EOF
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi